//!
//! @file main.c,v
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : ͖JԂɊÂ܂B
//!
//! @version 1.21
//!

//_____ ݸٰ _______________________________________________________________
#include "config.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

#include "adc\adc_drv.h"
#include "mc_test_procedure.h"

#include "uart\uart_lib.h"
#include "ushell_task.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

//_____ 錾 __________________________________________________________________
U16 g_regulation_period = 0;	//!< ̎`
U16 motor_speed = 0;			//!< gpґxw
extern Bool g_tick;				// ̎掞ԂɎgpAmc_drv.cɂĐ

U8 PWMxB = 0;					//!< AT90PWM3̉ł^܂B

void get_part_revision(void)
{
  ADCSRA |= (1 << ADEN);		// ADCSRBADASCRݒł悤A/Dϊ
  ADCSRB |= (1 << ADASCR);		// ADCSRBڼ޽ADASCRݒ(1)
  if (ADCSRB & (1<<ADASCR))		// (݌ADASCRޯĒ) AT90PWM2/3ŁA
  {
	ADCSRB &= ~(1 << ADASCR);	// svϊJnȂ悤ɖ{ޯĉ(0)
	PWMxB = 0;					// B׸މ
  }
  else							// AT90PWN2B/3B
  {
	PWMxB = 1;					// B׸ސݒ
  }
  ADCSRA &= ~(1 << ADEN);		// svȂ̂ňUA/Dϊ֎~
}


//! {̓
//!
//! d@䉞p̂߂̖{̓_\n
//! mc_regulation_loop()֐80msɎn܂B\n
//!
int main(void)
{

  get_part_revision();

  // d@
  mc_init();								// d@p̏Jn

  if(Get_EXT3() == 0)						// PB5=0ŁA
  {
	uart_init();							// USART
	mc_manufacturing_test();				// ֐Jn(Ɏgp)
  }

  // UARTʂOߗp̒ʐMт
  ushell_task_init();

  // d@n
  mci_set_motor_speed(0);
  mci_run();

  while(1)
  {
	// JԂJn
	// v1S250sŊ荞(g_tick)𐶐܂B
	// ̎=n~250s
	if (g_tick == TRUE)
	{
	  g_tick = FALSE;
	  // dƉϒR̒l擾
	  mc_ADC_Scheduler();
	  g_regulation_period += 1;
	  if ( g_regulation_period >= 320 )		// n~250s=Te
	  {
		g_regulation_period = 0;
		if (ushell_active == FALSE)
		{
		  // ϒRŎgpґxwݒ
		  mci_set_motor_speed(mc_get_potentiometer_value());
		}
		mc_regulation_loop();				// JԂJn
	  }
	  ushell_task();
	  mc_inrush_task();						// dǗ
	}
	// ߓdɏ]PSCԂ\
	if(PCTL2 & (1<<PRUN2))  switch_OFF_LED();	// PSC ONLED
	else  switch_ON_LED();						// PSC OFFLED_(ߓd)
  }
}
